freedombone-app-pleroma 51KB

1234567891011121314151617181920212223242526272829303132333435363738394041424344454647484950515253545556575859606162636465666768697071727374757677787980818283848586878889909192939495969798991001011021031041051061071081091101111121131141151161171181191201211221231241251261271281291301311321331341351361371381391401411421431441451461471481491501511521531541551561571581591601611621631641651661671681691701711721731741751761771781791801811821831841851861871881891901911921931941951961971981992002012022032042052062072082092102112122132142152162172182192202212222232242252262272282292302312322332342352362372382392402412422432442452462472482492502512522532542552562572582592602612622632642652662672682692702712722732742752762772782792802812822832842852862872882892902912922932942952962972982993003013023033043053063073083093103113123133143153163173183193203213223233243253263273283293303313323333343353363373383393403413423433443453463473483493503513523533543553563573583593603613623633643653663673683693703713723733743753763773783793803813823833843853863873883893903913923933943953963973983994004014024034044054064074084094104114124134144154164174184194204214224234244254264274284294304314324334344354364374384394404414424434444454464474484494504514524534544554564574584594604614624634644654664674684694704714724734744754764774784794804814824834844854864874884894904914924934944954964974984995005015025035045055065075085095105115125135145155165175185195205215225235245255265275285295305315325335345355365375385395405415425435445455465475485495505515525535545555565575585595605615625635645655665675685695705715725735745755765775785795805815825835845855865875885895905915925935945955965975985996006016026036046056066076086096106116126136146156166176186196206216226236246256266276286296306316326336346356366376386396406416426436446456466476486496506516526536546556566576586596606616626636646656666676686696706716726736746756766776786796806816826836846856866876886896906916926936946956966976986997007017027037047057067077087097107117127137147157167177187197207217227237247257267277287297307317327337347357367377387397407417427437447457467477487497507517527537547557567577587597607617627637647657667677687697707717727737747757767777787797807817827837847857867877887897907917927937947957967977987998008018028038048058068078088098108118128138148158168178188198208218228238248258268278288298308318328338348358368378388398408418428438448458468478488498508518528538548558568578588598608618628638648658668678688698708718728738748758768778788798808818828838848858868878888898908918928938948958968978988999009019029039049059069079089099109119129139149159169179189199209219229239249259269279289299309319329339349359369379389399409419429439449459469479489499509519529539549559569579589599609619629639649659669679689699709719729739749759769779789799809819829839849859869879889899909919929939949959969979989991000100110021003100410051006100710081009101010111012101310141015101610171018101910201021102210231024102510261027102810291030103110321033103410351036103710381039104010411042104310441045104610471048104910501051105210531054105510561057105810591060106110621063106410651066106710681069107010711072107310741075107610771078107910801081108210831084108510861087108810891090109110921093109410951096109710981099110011011102110311041105110611071108110911101111111211131114111511161117111811191120112111221123112411251126112711281129113011311132113311341135113611371138113911401141114211431144114511461147114811491150115111521153115411551156115711581159116011611162116311641165116611671168116911701171117211731174117511761177117811791180118111821183118411851186118711881189119011911192119311941195119611971198119912001201120212031204120512061207120812091210121112121213121412151216121712181219122012211222122312241225122612271228122912301231123212331234123512361237123812391240124112421243124412451246124712481249125012511252125312541255125612571258125912601261126212631264126512661267126812691270127112721273127412751276127712781279128012811282128312841285128612871288128912901291129212931294129512961297129812991300130113021303130413051306130713081309131013111312131313141315131613171318131913201321132213231324132513261327132813291330133113321333133413351336133713381339134013411342134313441345134613471348134913501351135213531354135513561357135813591360136113621363136413651366136713681369137013711372137313741375137613771378137913801381138213831384
  1. #!/bin/bash
  2. # _____ _ _
  3. # | __|___ ___ ___ _| |___ _____| |_ ___ ___ ___
  4. # | __| _| -_| -_| . | . | | . | . | | -_|
  5. # |__| |_| |___|___|___|___|_|_|_|___|___|_|_|___|
  6. #
  7. # Freedom in the Cloud
  8. #
  9. # Pleroma backend application
  10. #
  11. # License
  12. # =======
  13. #
  14. # Copyright (C) 2017-2018 Bob Mottram <bob@freedombone.net>
  15. #
  16. # This program is free software: you can redistribute it and/or modify
  17. # it under the terms of the GNU Affero General Public License as published by
  18. # the Free Software Foundation, either version 3 of the License, or
  19. # (at your option) any later version.
  20. #
  21. # This program is distributed in the hope that it will be useful,
  22. # but WITHOUT ANY WARRANTY; without even the implied warranty of
  23. # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
  24. # GNU Affero General Public License for more details.
  25. #
  26. # You should have received a copy of the GNU Affero General Public License
  27. # along with this program. If not, see <http://www.gnu.org/licenses/>.
  28. VARIANTS='full full-vim social'
  29. IN_DEFAULT_INSTALL=0
  30. SHOW_ON_ABOUT=1
  31. PLEROMA_DOMAIN_NAME=
  32. PLEROMA_CODE=
  33. PLEROMA_PORT=4000
  34. PLEROMA_ONION_PORT=8011
  35. PLEROMA_REPO="https://git.pleroma.social/pleroma/pleroma.git"
  36. PLEROMA_COMMIT='6b9a6838331210dd514d5ecda52783c183bd1bbf'
  37. PLEROMA_ADMIN_PASSWORD=
  38. PLEROMA_DIR=/etc/pleroma
  39. PLEROMA_SECRET_KEY=""
  40. pleroma_secret=$PLEROMA_DIR/config/dev.secret.exs
  41. PLEROMA_BACKGROUND_IMAGE_URL=
  42. PLEROMA_TITLE='Pleroma Server'
  43. # Number of months after which posts expire
  44. PLEROMA_EXPIRE_MONTHS=3
  45. pleroma_expire_posts_script=/usr/bin/pleroma-expire-posts
  46. blocking_script_file=/usr/bin/pleroma-blocking
  47. pleroma_variables=(ONION_ONLY
  48. PLEROMA_DOMAIN_NAME
  49. PLEROMA_CODE
  50. PLEROMA_WELCOME_MESSAGE
  51. PLEROMA_BACKGROUND_IMAGE_URL
  52. DDNS_PROVIDER
  53. PLEROMA_TITLE
  54. PLEROMA_EXPIRE_MONTHS
  55. MY_EMAIL_ADDRESS
  56. MY_USERNAME)
  57. function pleroma_add_filtering {
  58. if grep -q "# begin filtering" $pleroma_secret; then
  59. return
  60. fi
  61. sed -i '/pbkdf2_rounds/a reject: []' $pleroma_secret
  62. sed -i '/pbkdf2_rounds/a federated_timeline_removal: [],' $pleroma_secret
  63. sed -i '/pbkdf2_rounds/a media_nsfw: [],' $pleroma_secret
  64. sed -i '/pbkdf2_rounds/a media_removal: [],' $pleroma_secret
  65. sed -i '/pbkdf2_rounds/a config :pleroma, :mrf_simple,' $pleroma_secret
  66. sed -i '/pbkdf2_rounds/a # begin filtering' $pleroma_secret
  67. sed -i 's|reject: | reject: |g' $pleroma_secret
  68. sed -i 's|federated_timeline_removal: | federated_timeline_removal: |g' $pleroma_secret
  69. sed -i 's|media_nsfw: | media_nsfw: |g' $pleroma_secret
  70. sed -i 's|media_removal: | media_removal: |g' $pleroma_secret
  71. create_pleroma_blocklist
  72. }
  73. function pleroma_enable_chat {
  74. if [[ "$1" == 't'* || "$1" == 'y'* || "$1" == 'T'* || "$1" == 'Y'* ]]; then
  75. sed -i 's|"chatDisabled":.*|"chatDisabled": false,|g' $PLEROMA_DIR/priv/static/static/config.json
  76. sed -i 's|:chat, enabled:.*|:chat, enabled: true|g' $PLEROMA_DIR/config/config.exs
  77. else
  78. sed -i 's|"chatDisabled":.*|"chatDisabled": true,|g' $PLEROMA_DIR/priv/static/static/config.json
  79. sed -i 's|:chat, enabled:.*|:chat, enabled: false|g' $PLEROMA_DIR/config/config.exs
  80. fi
  81. pleroma_recompile
  82. }
  83. function create_pleroma_blocklist {
  84. { echo '#!/bin/bash';
  85. echo "if [ ! -f /root/${PROJECT_NAME}-firewall-domains.cfg ]; then";
  86. echo ' exit 0';
  87. echo 'fi';
  88. echo 'if [ -f /tmp/pleroma-blocking.lock ]; then';
  89. echo ' cd /tmp';
  90. echo ' find ./pleroma*.lock -type f -mmin +5 -exec rm {} \;';
  91. echo ' if [ -f /tmp/pleroma-blocking.lock ]; then';
  92. echo ' exit 0';
  93. echo ' fi';
  94. echo 'fi';
  95. echo 'touch /tmp/pleroma-blocking.lock';
  96. echo 'objects_query="DELETE FROM objects WHERE"';
  97. echo 'objects_updated=';
  98. echo 'users_query="DELETE FROM users WHERE"';
  99. echo 'websub_server_subscriptions_query="DELETE FROM websub_server_subscriptions WHERE"';
  100. echo 'websub_server_subscriptions_updated=';
  101. echo 'filter_str=';
  102. echo 'while read blocked; do';
  103. echo " if [[ \"\$blocked\" == *\".\"* || \"\$blocked\" == *\"@\"* ]]; then";
  104. echo " if [ \${#blocked} -gt 4 ]; then";
  105. echo " if [ \$objects_updated ]; then";
  106. echo " objects_query=\"\${objects_query} or\"";
  107. echo " users_query=\"\${users_query} or\"";
  108. echo ' fi';
  109. echo " objects_query=\"\${objects_query} data->>'content' ilike '%\${blocked}%' or data->>'actor' ilike '%\${blocked}%' or data->>'to' ilike '%\${blocked}%' or data->>'id' ilike '%\${blocked}%' or data->>'external_url' ilike '%\${blocked}%'\"";
  110. echo " users_query=\"\${users_query} nickname ilike '%\${blocked}%'\"";
  111. echo ' objects_updated=1';
  112. echo " if [[ \"\$blocked\" != *\"@\"* ]]; then";
  113. echo ' # Create a filter string for the pleroma configuration';
  114. echo " if [ \"\$filter_str\" ]; then";
  115. echo " filter_str=\"\${filter_str}, \\\"\$blocked\\\"\"";
  116. echo ' else';
  117. echo " filter_str=\"\\\"\${blocked}\\\"\"";
  118. echo ' fi';
  119. echo '';
  120. echo " if ! grep -q \"127.0.0.1 \$blocked\" /etc/hosts; then";
  121. echo " echo \"127.0.0.1 \$blocked\" >> /etc/hosts";
  122. echo ' fi';
  123. echo " if [ \$websub_server_subscriptions_updated ]; then";
  124. echo " websub_server_subscriptions_query=\"\${websub_server_subscriptions_query} or\"";
  125. echo ' fi';
  126. echo " websub_server_subscriptions_query=\"\${websub_server_subscriptions_query} callback like '%\${blocked}%'\"";
  127. echo ' websub_server_subscriptions_updated=1';
  128. echo ' fi';
  129. echo ' fi';
  130. echo ' fi';
  131. echo 'done </root/freedombone-firewall-domains.cfg';
  132. echo '';
  133. echo "if [ \"\$filter_str\" ]; then";
  134. echo " if ! grep -q \" \$filter_str \" $pleroma_secret; then";
  135. echo " sed -i \"s| media_removal:.*| media_removal: [ \$filter_str ],|g\" $pleroma_secret";
  136. echo " sed -i \"s| federated_timeline_removal:.*| federated_timeline_removal: [ \$filter_str ],|g\" $pleroma_secret";
  137. echo " sed -i \"s| reject:.*| reject: [ \$filter_str ]|g\" $pleroma_secret";
  138. echo " chown -R pleroma:pleroma $PLEROMA_DIR";
  139. echo ' sudo -u pleroma mix clean';
  140. echo ' sudo -u pleroma mix deps.compile';
  141. echo ' sudo -u pleroma mix compile';
  142. echo ' systemctl restart pleroma';
  143. echo ' fi';
  144. echo 'fi';
  145. echo '';
  146. echo 'cd /etc/postgresql';
  147. echo "if [ \$objects_updated ]; then";
  148. echo " sudo -u postgres psql -d pleroma -c \"\$objects_query\"";
  149. echo " sudo -u postgres psql -d pleroma -c \"\$users_query\"";
  150. echo 'fi';
  151. echo "if [ \$websub_server_subscriptions_updated ]; then";
  152. echo " sudo -u postgres psql -d pleroma -c \"\$websub_server_subscriptions_query\"";
  153. echo 'fi';
  154. echo 'rm /tmp/pleroma-blocking.lock'; } > $blocking_script_file
  155. chmod +x $blocking_script_file
  156. if ! grep -q "$blocking_script_file" /etc/crontab; then
  157. cron_add_mins 1 "$blocking_script_file 2> /dev/null"
  158. fi
  159. }
  160. function expire_pleroma_posts {
  161. domain_name=$1
  162. expire_months=$3
  163. if [ ! "$expire_months" ]; then
  164. expire_months=3
  165. fi
  166. #expire_days=$((expire_months * 30))
  167. # files are what take up most of the backup time, so don't keep them for very long
  168. expire_days_files=7
  169. # To prevent the database size from growing endlessly this script expires posts
  170. # after a number of months
  171. if [ ! -d /etc/pleroma ]; then
  172. return
  173. fi
  174. { echo '#!/bin/bash';
  175. echo "plmonths=\"$PLEROMA_EXPIRE_MONTHS\"";
  176. echo "if [ \${#plmonths} -eq 0 ]; then";
  177. echo ' exit 1';
  178. echo 'fi';
  179. echo "if [[ \"\$plmonths\" == \"0\" ]]; then";
  180. echo ' exit 2';
  181. echo 'fi';
  182. echo "oldate=\$(date +%Y-%m-%d --date=\"\$plmonths months ago\")";
  183. echo 'cd /etc/postgresql';
  184. echo "sudo -u postgres psql -d pleroma -c \"DELETE FROM notifications WHERE inserted_at <= '\$oldate 01:01:01'\"";
  185. echo "sudo -u postgres psql -d pleroma -c \"DELETE FROM objects WHERE inserted_at <= '\$oldate 01:01:01'\""; } > $pleroma_expire_posts_script
  186. chmod +x $pleroma_expire_posts_script
  187. pleroma_expire_script=/etc/cron.daily/pleroma-expire
  188. expire_days_files_threshold=$((expire_days_files - 1))
  189. { echo '#!/bin/bash';
  190. echo 'cd /etc/postgresql';
  191. echo 'if [ -d /etc/pleroma/tempfiles ]; then';
  192. echo ' rm -rf /etc/pleroma/tempfiles';
  193. echo 'fi';
  194. echo '';
  195. echo '# make directory to temporarily store local avatars';
  196. echo 'mkdir /etc/pleroma/tempfiles';
  197. echo '';
  198. echo '# get the local avatar files';
  199. echo "avatars=\$(sudo -u postgres psql -d pleroma -c \"select avatar->>'url' from users where avatar->>'url' like '%${domain_name}%'\")";
  200. echo '';
  201. echo '# copy the avatar files to a temporary directory';
  202. echo "arr=( \$avatars )";
  203. echo "for i in \${arr[@]}; do";
  204. echo " if [[ \"\$i\" == *'/media/'* ]]; then";
  205. echo " imagefile=/etc/pleroma/uploads/\$(echo \$i | sed 's|\"||g' | sed 's|,||g' | awk -F '/media/' '{print \$2}');";
  206. echo " if [ -f \$imagefile ]; then";
  207. echo " imagedir=/etc/pleroma/uploads/\$(echo \$i | sed 's|\"||g' | sed 's|,||g' | awk -F '/media/' '{print \$2}' | awk -F '/' '{print \$1}')";
  208. echo " nowdate=\$(date +%s)";
  209. echo " sinceepoch=\$(date +%s -r \$imagefile)";
  210. echo " daysold=\$(((\$nowdate - \$sinceepoch) / 86400))";
  211. echo " if [ \$daysold -ge ${expire_days_files_threshold} ]; then";
  212. echo " if [ ! -d \$imagedir ]; then";
  213. echo " mkdir \$imagedir";
  214. echo ' fi';
  215. echo " cp -rp \$imagefile \$imagedir";
  216. echo ' fi';
  217. echo ' fi';
  218. echo ' fi';
  219. echo 'done';
  220. echo '';
  221. echo '# get the local banner files';
  222. echo "banners=\$(sudo -u postgres psql -d pleroma -c \"select avatar->>'banner' from users where avatar->>'url' like '%${domain_name}%'\")";
  223. echo '';
  224. echo '# copy the banner files to a temporary directory';
  225. echo "arr=( \$banners )";
  226. echo "for i in \${arr[@]}; do";
  227. echo " if [[ \"\$i\" == *'/media/'* ]]; then";
  228. echo " imagefile=/etc/pleroma/uploads/\$(echo \$i | sed 's|\"||g' | sed 's|,||g' | awk -F '/media/' '{print \$2}');";
  229. echo " if [ -f \$imagefile ]; then";
  230. echo " imagedir=/etc/pleroma/uploads/\$(echo \$i | sed 's|\"||g' | sed 's|,||g' | awk -F '/media/' '{print \$2}' | awk -F '/' '{print \$1}')";
  231. echo " nowdate=\$(date +%s)";
  232. echo " sinceepoch=\$(date +%s -r \$imagefile)";
  233. echo " daysold=\$(((\$nowdate - \$sinceepoch) / 86400))";
  234. echo " if [ \$daysold -ge ${expire_days_files_threshold} ]; then";
  235. echo " if [ ! -d \$imagedir ]; then";
  236. echo " mkdir \$imagedir";
  237. echo ' fi';
  238. echo " cp -rp \$imagefile \$imagedir";
  239. echo ' fi';
  240. echo ' fi';
  241. echo ' fi';
  242. echo 'done';
  243. echo '';
  244. echo '# delete old files';
  245. echo "find /etc/pleroma/uploads/* -mtime +${expire_days_files} -exec rm -rf {} +";
  246. echo '';
  247. echo '# move avatar files back to uploads';
  248. echo 'chown -R pleroma:pleroma /etc/pleroma/tempfiles';
  249. echo 'mv /etc/pleroma/tempfiles/* /etc/pleroma/uploads';
  250. echo 'rm -rf /etc/pleroma/tempfiles';
  251. echo '';
  252. echo '/usr/bin/pleroma-expire-posts 2> /dev/null'; } > $pleroma_expire_script
  253. chmod +x $pleroma_expire_script
  254. # remove any old cron job
  255. if grep -q "pleroma-expire" /etc/crontab; then
  256. sed -i "/pleroma-expire/d" /etc/crontab
  257. rm /usr/bin/pleroma-expire
  258. fi
  259. # remove old expire script
  260. if [ -f /etc/cron.weekly/clear-pleroma-database ]; then
  261. rm /etc/cron.weekly/clear-pleroma-database
  262. fi
  263. }
  264. function pleroma_recompile {
  265. # necessary after parameter changes
  266. chown -R pleroma:pleroma $PLEROMA_DIR
  267. sudo -u pleroma mix clean
  268. sudo -u pleroma mix deps.compile
  269. sudo -u pleroma mix compile
  270. if [ -f /etc/systemd/system/pleroma.service ]; then
  271. systemctl restart pleroma
  272. fi
  273. }
  274. function logging_on_pleroma {
  275. echo -n ''
  276. }
  277. function logging_off_pleroma {
  278. echo -n ''
  279. }
  280. function remove_user_pleroma {
  281. remove_username="$1"
  282. cd $PLEROMA_DIR || exit 252498
  283. mix rm_user "$remove_username"
  284. "${PROJECT_NAME}-pass" -u "$remove_username" --rmapp pleroma
  285. }
  286. function add_user_pleroma {
  287. new_username="$1"
  288. new_user_password="$2"
  289. cd $PLEROMA_DIR || exit 348346
  290. mix register_user "$new_username" "$new_username" "$new_username@$HOSTNAME" $"Your bio goes here" "$new_user_password"
  291. "${PROJECT_NAME}-pass" -u "$new_username" -a pleroma -p "$new_user_password"
  292. echo '0'
  293. }
  294. function install_interactive_pleroma {
  295. if [ ! "$ONION_ONLY" ]; then
  296. ONION_ONLY='no'
  297. fi
  298. if [[ $ONION_ONLY != "no" ]]; then
  299. PLEROMA_DOMAIN_NAME='pleroma.local'
  300. else
  301. PLEROMA_DETAILS_COMPLETE=
  302. while [ ! $PLEROMA_DETAILS_COMPLETE ]
  303. do
  304. data=$(mktemp 2>/dev/null)
  305. if [[ "$DDNS_PROVIDER" == *"freedns"* ]]; then
  306. dialog --backtitle $"Freedombone Configuration" \
  307. --title $"Pleroma Configuration" \
  308. --form $"\\nPlease enter your Pleroma details. The background image URL can be left blank.\\n\\nIMPORTANT: This should be a domain name which is supported by Let's Encrypt:" 16 65 4 \
  309. $"Domain:" 1 1 "$(grep 'PLEROMA_DOMAIN_NAME' temp.cfg | awk -F '=' '{print $2}')" 1 25 33 40 \
  310. $"Title:" 2 1 "$(grep "$PLEROMA_TITLE" temp.cfg | awk -F '=' '{print $2}')" 2 25 255 255 \
  311. $"Background image URL:" 3 1 "$(grep "$PLEROMA_BACKGROUND_IMAGE_URL" temp.cfg | awk -F '=' '{print $2}')" 3 25 255 255 \
  312. $"Code:" 4 1 "$(grep 'PLEROMA_CODE' temp.cfg | awk -F '=' '{print $2}')" 4 25 33 255 \
  313. 2> "$data"
  314. else
  315. dialog --backtitle $"Freedombone Configuration" \
  316. --title $"Pleroma Configuration" \
  317. --form $"\\nPlease enter your Pleroma details. The background image URL can be left blank.\\n\\nIMPORTANT: This should be a domain name which is supported by Let's Encrypt:" 16 65 4 \
  318. $"Domain:" 1 1 "$(grep 'PLEROMA_DOMAIN_NAME' temp.cfg | awk -F '=' '{print $2}')" 1 25 33 40 \
  319. $"Title:" 2 1 "$(grep "$PLEROMA_TITLE" temp.cfg | awk -F '=' '{print $2}')" 2 25 255 255 \
  320. $"Background image URL:" 3 1 "$(grep "$PLEROMA_BACKGROUND_IMAGE_URL" temp.cfg | awk -F '=' '{print $2}')" 3 25 255 255 \
  321. 2> "$data"
  322. fi
  323. sel=$?
  324. case $sel in
  325. 1) rm -f "$data"
  326. exit 1;;
  327. 255) rm -f "$data"
  328. exit 1;;
  329. esac
  330. PLEROMA_DOMAIN_NAME=$(sed -n 1p < "$data")
  331. title=$(sed -n 2p < "$data")
  332. if [ ${#title} -gt 1 ]; then
  333. PLEROMA_TITLE="$title"
  334. fi
  335. img_url=$(sed -n 3p < "$data")
  336. if [ ${#img_url} -gt 1 ]; then
  337. PLEROMA_BACKGROUND_IMAGE_URL=$img_url
  338. fi
  339. if [ "$PLEROMA_DOMAIN_NAME" ]; then
  340. if [[ $PLEROMA_DOMAIN_NAME == "$HUBZILLA_DOMAIN_NAME" ]]; then
  341. PLEROMA_DOMAIN_NAME=""
  342. fi
  343. TEST_DOMAIN_NAME=$PLEROMA_DOMAIN_NAME
  344. validate_domain_name
  345. if [[ "$TEST_DOMAIN_NAME" != "$PLEROMA_DOMAIN_NAME" ]]; then
  346. PLEROMA_DOMAIN_NAME=
  347. dialog --title $"Domain name validation" --msgbox "$TEST_DOMAIN_NAME" 15 50
  348. else
  349. if [[ "$DDNS_PROVIDER" == *"freedns"* ]]; then
  350. PLEROMA_CODE=$(sed -n 4p < "$data")
  351. validate_freedns_code "$PLEROMA_CODE"
  352. if [ ! "$VALID_CODE" ]; then
  353. PLEROMA_DOMAIN_NAME=
  354. fi
  355. fi
  356. fi
  357. fi
  358. if [ $PLEROMA_DOMAIN_NAME ]; then
  359. PLEROMA_DETAILS_COMPLETE="yes"
  360. fi
  361. rm -f "$data"
  362. done
  363. # remove any invalid characters
  364. if [ ${#PLEROMA_TITLE} -gt 0 ]; then
  365. new_title=${PLEROMA_TITLE//\'/}
  366. PLEROMA_TITLE="$new_title"
  367. fi
  368. # save the results in the config file
  369. write_config_param "PLEROMA_CODE" "$PLEROMA_CODE"
  370. write_config_param "PLEROMA_TITLE" "$PLEROMA_TITLE"
  371. write_config_param "PLEROMA_BACKGROUND_IMAGE_URL" "$PLEROMA_BACKGROUND_IMAGE_URL"
  372. fi
  373. write_config_param "PLEROMA_DOMAIN_NAME" "$PLEROMA_DOMAIN_NAME"
  374. APP_INSTALLED=1
  375. }
  376. function change_password_pleroma {
  377. # curr_username="$1"
  378. new_user_password="$2"
  379. #${PROJECT_NAME}-pass -u "$curr_username" -a pleroma -p "$new_user_password"
  380. }
  381. function pleroma_create_database_failed {
  382. run_system_query_postgresql "ALTER USER pleroma NOSUPERUSER;"
  383. run_system_query_postgresql "ALTER USER pleroma NOCREATEDB;"
  384. }
  385. function pleroma_create_database {
  386. if [ -f "$IMAGE_PASSWORD_FILE" ]; then
  387. PLEROMA_ADMIN_PASSWORD="$(printf "%s" "$(cat "$IMAGE_PASSWORD_FILE")")"
  388. else
  389. if [ ! "$PLEROMA_ADMIN_PASSWORD" ]; then
  390. PLEROMA_ADMIN_PASSWORD="$(create_password "${MINIMUM_PASSWORD_LENGTH}")"
  391. fi
  392. fi
  393. if [ ! "$PLEROMA_ADMIN_PASSWORD" ]; then
  394. return
  395. fi
  396. systemctl restart postgresql
  397. add_postgresql_user pleroma "$PLEROMA_ADMIN_PASSWORD" encrypted
  398. run_system_query_postgresql "create database pleroma;"
  399. # temporarily allow the user to create databases
  400. run_system_query_postgresql "ALTER USER pleroma CREATEDB;"
  401. run_system_query_postgresql "ALTER USER pleroma SUPERUSER;"
  402. run_system_query_postgresql "GRANT ALL ON ALL tables IN SCHEMA public TO pleroma;"
  403. run_system_query_postgresql "GRANT ALL ON ALL sequences IN SCHEMA public TO pleroma;"
  404. run_system_query_postgresql "CREATE EXTENSION citext;"
  405. run_system_query_postgresql "set statement_timeout to 40000;"
  406. read_config_param "PLEROMA_SECRET_KEY"
  407. if [ ${#PLEROMA_SECRET_KEY} -lt 64 ]; then
  408. PLEROMA_SECRET_KEY="$(create_password 30)$(create_password 30)$(create_password 30)"
  409. if [ ${#PLEROMA_SECRET_KEY} -lt 64 ]; then
  410. pleroma_create_database_failed
  411. echo $'Pleroma secret key not created'
  412. exit 6782352
  413. fi
  414. write_config_param "PLEROMA_SECRET_KEY" "$PLEROMA_SECRET_KEY"
  415. fi
  416. if [ ! -d $PLEROMA_DIR/config ]; then
  417. echo $"Missing directory $PLEROMA_DIR/config"
  418. exit 7835393
  419. fi
  420. if [ ! -f $PLEROMA_DIR/config/dev.exs ]; then
  421. echo $"Did not find $PLEROMA_DIR/config/dev.exs"
  422. exit 78923528
  423. fi
  424. cp $PLEROMA_DIR/config/dev.exs $pleroma_secret
  425. sed -i "s|username:.*|username: \"pleroma\",|g" $pleroma_secret
  426. sed -i "s|password:.*|password: \"$PLEROMA_ADMIN_PASSWORD\",|g" $pleroma_secret
  427. sed -i "s|database:.*|database: \"pleroma\",|g" $pleroma_secret
  428. sed -i "/Pleroma.Web.Endpoint/a secret_key_base: \"$PLEROMA_SECRET_KEY\"," $pleroma_secret
  429. sed -i 's|secret_key_base: | secret_key_base: |g' $pleroma_secret
  430. sed -i "/Pleroma.Web.Endpoint/a pubsub: [name: Pleroma.Web.PubSub, adapter: Phoenix.PubSub.PG2]," $pleroma_secret
  431. sed -i 's|pubsub: | pubsub: |g' $pleroma_secret
  432. sed -i 's|watchers: []|watchers: [],|g' $pleroma_secret
  433. if [[ $ONION_ONLY == 'no' ]]; then
  434. sed -i "/watchers: []/a url: [host: \"$PLEROMA_DOMAIN_NAME\", scheme: \"https\", port: 443]" $pleroma_secret
  435. else
  436. sed -i "/watchers: []/a url: [host: \"$PLEROMA_ONION_HOSTNAME\", scheme: \"http\", port: 80]" $pleroma_secret
  437. fi
  438. sed -i 's|url: | url: |g' $pleroma_secret
  439. if ! grep -q "pbkdf2_rounds" $pleroma_secret; then
  440. sed -i '/config :logger/a config :comeonin, :pbkdf2_rounds, 1' $pleroma_secret
  441. else
  442. sed -i 's|pbkdf2_rounds.*|pbkdf2_rounds, 1|g' $pleroma_secret
  443. fi
  444. sed -i 's|import_config|# import_config|g' $pleroma_secret
  445. cd "$PLEROMA_DIR" || exit 678245245724
  446. chown -R pleroma:pleroma $PLEROMA_DIR/*
  447. if ! sudo -u pleroma mix local.rebar --force; then
  448. pleroma_create_database_failed
  449. echo $'mix local.rebar failed'
  450. exit 73528562
  451. fi
  452. sudo -u pleroma mix local.hex --force
  453. sudo -u pleroma mix deps.compile mimerl
  454. systemctl restart postgresql
  455. if ! sudo -u pleroma mix ecto.create --force; then
  456. pleroma_create_database_failed
  457. echo $'mix ecto.create failed'
  458. exit 83653582
  459. fi
  460. if ! sudo -u pleroma mix ecto.migrate --force; then
  461. pleroma_create_database_failed
  462. echo $'mix ecto.migrate failed'
  463. exit 73752573
  464. fi
  465. # revoke the ability to create databases for this user
  466. run_system_query_postgresql "ALTER USER pleroma NOSUPERUSER;"
  467. run_system_query_postgresql "ALTER USER pleroma NOCREATEDB;"
  468. }
  469. function reconfigure_pleroma {
  470. echo -n ''
  471. }
  472. function pleroma_set_background_image {
  473. PLEROMA_DOMAIN_NAME=$(get_completion_param "pleroma domain")
  474. data=$(mktemp 2>/dev/null)
  475. dialog --title $"Pleroma" \
  476. --backtitle $"Freedombone Control Panel" \
  477. --inputbox $'Set a background image URL' 10 60 2>"$data"
  478. sel=$?
  479. case $sel in
  480. 0)
  481. temp_background=$(<"$data")
  482. if [ ${#temp_background} -gt 0 ]; then
  483. PLEROMA_BACKGROUND_IMAGE_URL="$temp_background"
  484. write_config_param "PLEROMA_BACKGROUND_IMAGE_URL" "$PLEROMA_BACKGROUND_IMAGE_URL"
  485. if [[ $(pleroma_set_background_image_from_url $PLEROMA_DIR "$PLEROMA_DOMAIN_NAME" "$PLEROMA_BACKGROUND_IMAGE_URL" "$PLEROMA_TITLE" | tail -n 1) == "0" ]]; then
  486. pleroma_recompile
  487. dialog --title $"Set Pleroma login background" \
  488. --msgbox $"The background image has been set" 6 60
  489. fi
  490. fi
  491. ;;
  492. esac
  493. rm -f "$data"
  494. }
  495. function pleroma_set_title {
  496. data=$(mktemp 2>/dev/null)
  497. dialog --title $"Pleroma" \
  498. --backtitle $"Freedombone Control Panel" \
  499. --inputbox $'Set a title' 10 60 2>"$data"
  500. sel=$?
  501. case $sel in
  502. 0)
  503. new_title=$(<"$data")
  504. if [ ${#new_title} -gt 0 ]; then
  505. PLEROMA_TITLE="$new_title"
  506. PLEROMA_DOMAIN_NAME=$(get_completion_param "pleroma domain")
  507. write_config_param "PLEROMA_TITLE" "$PLEROMA_TITLE"
  508. sed -i "s|\"name\":.*|\"name\": \"${PLEROMA_TITLE}\",|g" $PLEROMA_DIR/static/config.json
  509. sed -i "s|\"name\":.*|\"name\": \"${PLEROMA_TITLE}\",|g" $PLEROMA_DIR/priv/static/static/config.json
  510. sed -i "s|name: .*|name: \"${PLEROMA_TITLE}\",|g" $PLEROMA_DIR/config/config.exs
  511. systemctl restart pleroma
  512. dialog --title $"Set Pleroma title" \
  513. --msgbox $"The title has been set" 6 60
  514. fi
  515. ;;
  516. esac
  517. rm -f "$data"
  518. }
  519. function pleroma_set_expire_months {
  520. PLEROMA_DOMAIN_NAME=$(get_completion_param "pleroma domain")
  521. read_config_param "PLEROMA_DOMAIN_NAME"
  522. read_config_param "PLEROMA_EXPIRE_MONTHS"
  523. data=$(mktemp 2>/dev/null)
  524. dialog --title $"Pleroma" \
  525. --backtitle $"Freedombone Control Panel" \
  526. --inputbox $'Set an expiry period for posts in months. Anything older will be deleted. Lower values help to keep the database size small and as fast as possible.' 12 60 "$PLEROMA_EXPIRE_MONTHS" 2>"$data"
  527. sel=$?
  528. case $sel in
  529. 0)
  530. new_expiry_months=$(<"$data")
  531. if [ ${#new_expiry_months} -gt 0 ]; then
  532. # should contain no spaces
  533. if [[ "$new_expiry_months" == *" "* ]]; then
  534. rm -f "$data"
  535. return
  536. fi
  537. # should be a number
  538. re='^[0-9]+$'
  539. if ! [[ $new_expiry_months =~ $re ]] ; then
  540. rm -f "$data"
  541. return
  542. fi
  543. # set the new value
  544. PLEROMA_EXPIRE_MONTHS=$new_expiry_months
  545. write_config_param "PLEROMA_EXPIRE_MONTHS" "$PLEROMA_EXPIRE_MONTHS"
  546. expire_pleroma_posts "$PLEROMA_DOMAIN_NAME" "$PLEROMA_EXPIRE_MONTHS"
  547. create_pleroma_blocklist
  548. dialog --title $"Set Pleroma post expiry period" \
  549. --msgbox $"Expiry period set to $PLEROMA_EXPIRE_MONTHS months" 6 60
  550. fi
  551. ;;
  552. esac
  553. rm -f "$data"
  554. }
  555. function pleroma_disable_registrations {
  556. dialog --title $"Disable new Pleroma user registrations" \
  557. --backtitle $"Freedombone Control Panel" \
  558. --yesno $"\\nDo you wish to disable new registrations?" 10 60
  559. sel=$?
  560. case $sel in
  561. 0) sed -i 's|registrations_open: true|registrations_open: false|g' $PLEROMA_DIR/config/config.exs
  562. sed -i 's|registrations_open: True|registrations_open: false|g' $PLEROMA_DIR/config/config.exs
  563. sed -i 's|"registrationOpen": true|"registrationOpen": false|g' $PLEROMA_DIR/priv/static/static/config.json
  564. sed -i 's|"registrationOpen": True|"registrationOpen": false|g' $PLEROMA_DIR/priv/static/static/config.json
  565. ;;
  566. 1) sed -i 's|registrations_open: false|registrations_open: true|g' $PLEROMA_DIR/config/config.exs
  567. sed -i 's|registrations_open: False|registrations_open: true|g' $PLEROMA_DIR/config/config.exs
  568. sed -i 's|"registrationOpen": false|"registrationOpen": true|g' $PLEROMA_DIR/priv/static/static/config.json
  569. sed -i 's|"registrationOpen": False|"registrationOpen": true|g' $PLEROMA_DIR/priv/static/static/config.json
  570. ;;
  571. 255) return;;
  572. esac
  573. pleroma_recompile
  574. }
  575. function pleroma_add_emoji {
  576. emoji_resolution='128x128'
  577. data=$(mktemp 2>/dev/null)
  578. dialog --backtitle $"Freedombone Control Panel" \
  579. --title $"Add Custom Emoji" \
  580. --form "\\n" 8 75 2 \
  581. $"Shortcode:" 1 1 "" 1 18 16 15 \
  582. $"ImageURL:" 2 1 "" 2 18 512 10000 \
  583. 2> "$data"
  584. sel=$?
  585. case $sel in
  586. 1) rm -f "$data"
  587. return;;
  588. 255) rm -f "$data"
  589. return;;
  590. esac
  591. shortcode=$(sed -n 1p < "$data")
  592. image_url=$(sed -n 2p < "$data")
  593. rm -f "$data"
  594. if [ ${#shortcode} -lt 2 ]; then
  595. return
  596. fi
  597. if [ ${#image_url} -lt 2 ]; then
  598. return
  599. fi
  600. if [[ "$image_url" != *'.'* ]]; then
  601. return
  602. fi
  603. if [[ "$image_url" != *'.png' && "$image_url" != *'.jpg' && "$image_url" != *'.jpeg' && "$image_url" != *'.gif' ]]; then
  604. dialog --title $"Add Custom Emoji" \
  605. --msgbox $"The image must be png/jpg/gif format" 6 60
  606. return
  607. fi
  608. if [[ "$shortcode" == *':'* || "$shortcode" == *' '* || "$shortcode" == *'.'* || "$shortcode" == *'!'* ]]; then
  609. dialog --title $"Add Custom Emoji" \
  610. --msgbox $"The shortcode contains invalid characters" 6 60
  611. return
  612. fi
  613. image_extension='png'
  614. if [[ "$image_url" == *'.jpg' || "$image_url" == *'.jpeg' ]]; then
  615. image_extension='jpg'
  616. fi
  617. if [[ "$image_url" == *'.gif' ]]; then
  618. image_extension='gif'
  619. fi
  620. if [ ! -d $PLEROMA_DIR/priv/static/emoji ]; then
  621. mkdir -p $PLEROMA_DIR/priv/static/emoji
  622. fi
  623. image_filename=$PLEROMA_DIR/priv/static/emoji/${shortcode}.${image_extension}
  624. wget "$image_url" -O "$image_filename"
  625. if [ ! -f "$image_filename" ]; then
  626. dialog --title $"Add Custom Emoji" \
  627. --msgbox $"Unable to download the image" 6 60
  628. return
  629. fi
  630. if [[ "$image_url" == *'.jpg' || "$image_url" == *'.jpeg' || "$image_url" == *'.gif' ]]; then
  631. convert "$image_filename" -resize "$emoji_resolution" "$PLEROMA_DIR/priv/static/emoji/${shortcode}.png"
  632. if [ ! -f "$PLEROMA_DIR/priv/static/emoji/${shortcode}.png" ]; then
  633. dialog --title $"Add Custom Emoji" \
  634. --msgbox $"Unable to convert empji image to png format" 6 60
  635. return
  636. fi
  637. # remove the original
  638. rm "$image_filename"
  639. image_extension='png'
  640. image_filename=$PLEROMA_DIR/priv/static/emoji/${shortcode}.${image_extension}
  641. else
  642. convert "$image_filename" -resize "$emoji_resolution" "$image_filename"
  643. fi
  644. if ! grep -q "${shortcode}," $PLEROMA_DIR/config/emoji.txt; then
  645. echo "${shortcode}, /emoji/${shortcode}.${image_extension}" >> $PLEROMA_DIR/config/emoji.txt
  646. else
  647. sed -i "s|${shortcode},.*|${shortcode}, /emoji/${shortcode}.${image_extension}|g" $PLEROMA_DIR/config/emoji.txt
  648. fi
  649. chown -R pleroma:pleroma $PLEROMA_DIR
  650. clear
  651. echo ''
  652. echo $'Recompiling Pleroma with the new emoji'
  653. systemctl stop pleroma
  654. pleroma_recompile
  655. dialog --title $"Add Custom Emoji" \
  656. --msgbox $"Custom emoji :${shortcode}: has been added" 6 70
  657. }
  658. function configure_interactive_pleroma {
  659. read_config_param PLEROMA_DOMAIN_NAME
  660. read_config_param PLEROMA_EXPIRE_MONTHS
  661. while true
  662. do
  663. chatenabled=
  664. enablechatstr=$'Enable chat system'
  665. if grep -q ':chat, enabled: true' $PLEROMA_DIR/config/config.exs; then
  666. chatenabled=1
  667. enablechatstr=$'Disable chat system'
  668. fi
  669. pleromatorstr=$'Enable routing through Tor for onion addresses'
  670. if grep -q '9050' $pleroma_secret; then
  671. pleromatorstr=$'Disable routing through Tor'
  672. fi
  673. W=(1 $"Set a background image"
  674. 2 $"Set the title"
  675. 3 $"Disable new account registrations"
  676. 4 $"Add a custom emoji"
  677. 5 $"Set post expiry period (currently $PLEROMA_EXPIRE_MONTHS months)"
  678. 6 "$enablechatstr"
  679. 7 "$pleromatorstr")
  680. # shellcheck disable=SC2068
  681. selection=$(dialog --backtitle $"Freedombone Administrator Control Panel" --title $"Pleroma" --menu $"Choose an operation, or ESC to exit:" 14 60 7 "${W[@]}" 3>&2 2>&1 1>&3)
  682. if [ ! "$selection" ]; then
  683. break
  684. fi
  685. case $selection in
  686. 1) pleroma_set_background_image;;
  687. 2) pleroma_set_title;;
  688. 3) pleroma_disable_registrations;;
  689. 4) pleroma_add_emoji;;
  690. 5) pleroma_set_expire_months;;
  691. 6) if [ $chatenabled ]; then
  692. pleroma_enable_chat false
  693. else
  694. pleroma_enable_chat true
  695. fi
  696. ;;
  697. 7) if grep -q '9050' $pleroma_secret; then
  698. pleroma_disable_tor
  699. else
  700. pleroma_enable_tor
  701. fi
  702. ;;
  703. esac
  704. done
  705. }
  706. function pleroma_disable_tor {
  707. if grep -q '9050' $pleroma_secret; then
  708. sed -i '/9050/d' $pleroma_secret
  709. sed -i 's|# config :pleroma, :http, proxy_url:|config :pleroma, :http, proxy_url:|g' $PLEROMA_DIR/config/config.exs
  710. pleroma_recompile
  711. fi
  712. }
  713. function pleroma_enable_tor {
  714. pleroma_tor_update=
  715. if ! grep -q '{:socks5, :localhost, 9050}' $pleroma_secret; then
  716. pleroma_tor_update=1
  717. fi
  718. if ! grep -q '# config :pleroma, :http, proxy_url:' $PLEROMA_DIR/config/config.exs; then
  719. pleroma_tor_update=1
  720. fi
  721. if [ ! $pleroma_tor_update ]; then
  722. return
  723. fi
  724. if ! grep -q '{:socks5, :localhost, 9050}' $pleroma_secret; then
  725. sed -i '/9050/d' $pleroma_secret
  726. sed -i '/url:/a config :pleroma, :http, proxy_url: {:socks5, :localhost, 9050}' $pleroma_secret
  727. fi
  728. if ! grep -q '# config :pleroma, :http, proxy_url:' $PLEROMA_DIR/config/config.exs; then
  729. sed -i 's|config :pleroma, :http, proxy_url:|# config :pleroma, :http, proxy_url:|g' $PLEROMA_DIR/config/config.exs
  730. fi
  731. pleroma_recompile
  732. }
  733. function upgrade_pleroma {
  734. read_config_param PLEROMA_DOMAIN_NAME
  735. read_config_param PLEROMA_EXPIRE_MONTHS
  736. pleroma_add_filtering
  737. if ! grep -q "/media/" /etc/cron.daily/pleroma-expire; then
  738. rm $pleroma_expire_posts_script
  739. fi
  740. if [ ! -f $pleroma_expire_posts_script ]; then
  741. expire_pleroma_posts "$PLEROMA_DOMAIN_NAME" "$PLEROMA_EXPIRE_MONTHS"
  742. fi
  743. if [ ! -f $blocking_script_file ]; then
  744. create_pleroma_blocklist
  745. fi
  746. #pleroma_enable_tor
  747. CURR_PLEROMA_COMMIT=$(get_completion_param "pleroma commit")
  748. if [[ "$CURR_PLEROMA_COMMIT" == "$PLEROMA_COMMIT" ]]; then
  749. return
  750. fi
  751. pleroma_registrations=open
  752. if grep -q 'registrations_open: false' $PLEROMA_DIR/config/config.exs; then
  753. pleroma_registrations=
  754. fi
  755. pleroma_chat_enabled=1
  756. if grep -q ':chat, enabled: false' $PLEROMA_DIR/config/config.exs; then
  757. pleroma_chat_enabled=
  758. fi
  759. # make a copy of the configuration
  760. cp $PLEROMA_DIR/priv/static/static/config.json $PLEROMA_DIR/priv/static/static/config_prev.json
  761. if [ -f $PLEROMA_DIR/config/emoji.txt ]; then
  762. cp $PLEROMA_DIR/config/emoji.txt $PLEROMA_DIR/config/emoji_prev.txt
  763. fi
  764. apt-get -yq update
  765. apt-get -yq install --only-upgrade esl-erlang
  766. apt-get -yq install --only-upgrade elixir erlang-xmerl erlang-dev erlang-parsetools
  767. function_check set_repo_commit
  768. set_repo_commit $PLEROMA_DIR "pleroma commit" "$PLEROMA_COMMIT" $PLEROMA_REPO
  769. chown -R pleroma:pleroma $PLEROMA_DIR
  770. # restore the configuration
  771. cp $PLEROMA_DIR/priv/static/static/config_prev.json $PLEROMA_DIR/priv/static/static/config.json
  772. chown pleroma:pleroma $PLEROMA_DIR/priv/static/static/config.json
  773. if [ -f $PLEROMA_DIR/config/emoji_prev.txt ]; then
  774. cp $PLEROMA_DIR/config/emoji_prev.txt $PLEROMA_DIR/config/emoji.txt
  775. chown pleroma:pleroma $PLEROMA_DIR/config/emoji.txt
  776. rm cp $PLEROMA_DIR/config/emoji_prev.txt
  777. fi
  778. sudo -u pleroma mix deps.get
  779. if [ ! $pleroma_registrations ]; then
  780. sed -i 's|registrations_open: true|registrations_open: false|g' $PLEROMA_DIR/config/config.exs
  781. sed -i 's|registrations_open: True|registrations_open: false|g' $PLEROMA_DIR/config/config.exs
  782. fi
  783. if [ ! $pleroma_chat_enabled ]; then
  784. sed -i 's|config :pleroma, :chat.*|config :pleroma, :chat, enabled: false|g' $PLEROMA_DIR/config/config.exs
  785. else
  786. sed -i 's|config :pleroma, :chat.*|config :pleroma, :chat, enabled: true|g' $PLEROMA_DIR/config/config.exs
  787. fi
  788. pleroma_recompile
  789. # migrate database
  790. sudo -u pleroma mix deps.clean --build mime
  791. sudo -u pleroma mix ecto.migrate
  792. pleroma_custom_logo "$PLEROMA_DIR"
  793. expire_pleroma_posts "$PLEROMA_DOMAIN_NAME" "$PLEROMA_EXPIRE_MONTHS"
  794. create_pleroma_blocklist
  795. chown -R pleroma:pleroma $PLEROMA_DIR
  796. systemctl restart pleroma
  797. }
  798. function backup_local_pleroma {
  799. PLEROMA_DOMAIN_NAME='pleroma'
  800. if grep -q "pleroma domain" "$COMPLETION_FILE"; then
  801. PLEROMA_DOMAIN_NAME=$(get_completion_param "pleroma domain")
  802. fi
  803. systemctl stop pleroma
  804. function_check suspend_site
  805. suspend_site "${PLEROMA_DOMAIN_NAME}"
  806. source_directory=$PLEROMA_DIR
  807. dest_directory=pleroma
  808. backup_directory_to_usb $source_directory $dest_directory
  809. USE_POSTGRESQL=1
  810. function_check backup_database_to_usb
  811. backup_database_to_usb pleroma
  812. function_check restart_site
  813. restart_site
  814. systemctl restart pleroma
  815. }
  816. function restore_local_pleroma {
  817. if ! grep -q "pleroma domain" "$COMPLETION_FILE"; then
  818. return
  819. fi
  820. PLEROMA_DOMAIN_NAME=$(get_completion_param "pleroma domain")
  821. if [ "$PLEROMA_DOMAIN_NAME" ]; then
  822. echo $"Restoring pleroma"
  823. temp_restore_dir=/root/temppleroma
  824. pleroma_dir=$PLEROMA_DIR
  825. systemctl stop pleroma
  826. PLEROMA_ONION_HOSTNAME=$(cat /var/lib/tor/hidden_service_pleroma/hostname)
  827. function_check pleroma_create_database
  828. pleroma_create_database
  829. USE_POSTGRESQL=1
  830. restore_database pleroma
  831. if [ -d $temp_restore_dir ]; then
  832. rm -rf $temp_restore_dir
  833. fi
  834. function_check restore_directory_from_usb
  835. restore_directory_from_usb $temp_restore_dir pleroma
  836. if [ -d $temp_restore_dir ]; then
  837. chown -R pleroma:pleroma $pleroma_dir
  838. rm -rf $temp_restore_dir
  839. fi
  840. systemctl restart pleroma
  841. echo $"Restore of pleroma complete"
  842. fi
  843. }
  844. function backup_remote_pleroma {
  845. PLEROMA_DOMAIN_NAME='pleroma'
  846. if grep -q "pleroma domain" "$COMPLETION_FILE"; then
  847. PLEROMA_DOMAIN_NAME=$(get_completion_param "pleroma domain")
  848. fi
  849. systemctl stop pleroma
  850. function_check suspend_site
  851. suspend_site "${PLEROMA_DOMAIN_NAME}"
  852. source_directory=$PLEROMA_DIR
  853. dest_directory=pleroma
  854. backup_directory_to_friend $source_directory $dest_directory
  855. USE_POSTGRESQL=1
  856. function_check backup_database_to_friend
  857. backup_database_to_friend pleroma
  858. function_check restart_site
  859. restart_site
  860. systemctl restart pleroma
  861. }
  862. function restore_remote_pleroma {
  863. if ! grep -q "pleroma domain" "$COMPLETION_FILE"; then
  864. return
  865. fi
  866. PLEROMA_DOMAIN_NAME=$(get_completion_param "pleroma domain")
  867. if [ "$PLEROMA_DOMAIN_NAME" ]; then
  868. echo $"Restoring pleroma"
  869. temp_restore_dir=/root/temppleroma
  870. pleroma_dir=$PLEROMA_DIR
  871. systemctl stop pleroma
  872. PLEROMA_ONION_HOSTNAME=$(cat /var/lib/tor/hidden_service_pleroma/hostname)
  873. function_check pleroma_create_database
  874. pleroma_create_database
  875. # shellcheck disable=SC2034
  876. USE_POSTGRESQL=1
  877. function_check restore_database_from_friend
  878. restore_database_from_friend pleroma
  879. if [ -d $temp_restore_dir ]; then
  880. rm -rf $temp_restore_dir
  881. fi
  882. function_check restore_directory_from_friend
  883. restore_directory_from_friend $temp_restore_dir pleroma
  884. if [ -d $temp_restore_dir ]; then
  885. chown -R pleroma:pleroma $pleroma_dir
  886. rm -rf $temp_restore_dir
  887. fi
  888. systemctl restart pleroma
  889. echo $"Restore of pleroma complete"
  890. fi
  891. }
  892. function remove_pleroma {
  893. if [ ${#PLEROMA_DOMAIN_NAME} -eq 0 ]; then
  894. return
  895. fi
  896. systemctl stop pleroma
  897. systemctl disable pleroma
  898. rm /etc/systemd/system/pleroma.service
  899. userdel pleroma
  900. #remove_elixir
  901. function_check remove_nodejs
  902. remove_nodejs pleroma-backend
  903. read_config_param "PLEROMA_DOMAIN_NAME"
  904. read_config_param "MY_USERNAME"
  905. echo "Removing $PLEROMA_DOMAIN_NAME"
  906. nginx_dissite "$PLEROMA_DOMAIN_NAME"
  907. remove_certs "$PLEROMA_DOMAIN_NAME"
  908. if [ -d "/var/www/$PLEROMA_DOMAIN_NAME" ]; then
  909. rm -rf "/var/www/$PLEROMA_DOMAIN_NAME"
  910. fi
  911. if [ -f "/etc/nginx/sites-available/$PLEROMA_DOMAIN_NAME" ]; then
  912. rm "/etc/nginx/sites-available/$PLEROMA_DOMAIN_NAME"
  913. fi
  914. if [ -d $PLEROMA_DIR ]; then
  915. rm -rf $PLEROMA_DIR
  916. fi
  917. function_check drop_database_postgresql
  918. drop_database_postgresql pleroma
  919. function_check remove_onion_service
  920. remove_onion_service pleroma ${PLEROMA_ONION_PORT}
  921. remove_app pleroma
  922. remove_completion_param install_pleroma
  923. sed -i '/pleroma domain/d' "$COMPLETION_FILE"
  924. sed -i '/pleroma commit/d' "$COMPLETION_FILE"
  925. sed -i "/$blocking_script_file/d" /etc/crontab
  926. if [ -f /usr/bin/pleroma-blocking ]; then
  927. rm /usr/bin/pleroma-blocking
  928. fi
  929. function_check remove_ddns_domain
  930. remove_ddns_domain "$PLEROMA_DOMAIN_NAME"
  931. }
  932. function image_install_pleroma {
  933. if [[ "$SOCIALINSTANCE" != 'pleroma' ]]; then
  934. return
  935. fi
  936. # shellcheck disable=SC2154
  937. chroot "$rootdir" apt-get -yq install wget imagemagick
  938. image_install_elixir
  939. image_install_postgresql
  940. }
  941. function install_pleroma {
  942. if [ ! $ONION_ONLY ]; then
  943. ONION_ONLY='no'
  944. fi
  945. apt-get -yq install wget imagemagick
  946. # We need elixir 1.4+ here, so the debian repo package won't do
  947. install_elixir
  948. function_check install_nodejs
  949. install_nodejs pleroma-backend
  950. install_postgresql
  951. if [ ! -d "/var/www/${PLEROMA_DOMAIN_NAME}/htdocs" ]; then
  952. mkdir -p "/var/www/${PLEROMA_DOMAIN_NAME}/htdocs"
  953. fi
  954. if [ -d $PLEROMA_DIR ]; then
  955. rm -rf $PLEROMA_DIR
  956. fi
  957. # get the repo
  958. if [ -f /repos/pleroma/index.html ]; then
  959. mv /repos/pleroma /repos/pleroma-fe
  960. fi
  961. if [ -d /repos/pleroma ]; then
  962. mkdir -p $PLEROMA_DIR
  963. cp -r -p /repos/pleroma/. $PLEROMA_DIR
  964. cd "$PLEROMA_DIR" || exit 834537453
  965. git pull
  966. else
  967. function_check git_clone
  968. git_clone $PLEROMA_REPO $PLEROMA_DIR
  969. fi
  970. if [ ! -d $PLEROMA_DIR ]; then
  971. echo $'Unable to clone pleroma backend repo'
  972. exit 783523
  973. fi
  974. # create user
  975. useradd -d $PLEROMA_DIR -s /bin/false pleroma
  976. # checkout the commit
  977. cd "$PLEROMA_DIR" || exit 62452428
  978. git checkout $PLEROMA_COMMIT -b $PLEROMA_COMMIT
  979. set_completion_param "pleroma commit" "$PLEROMA_COMMIT"
  980. chown -R pleroma:pleroma $PLEROMA_DIR
  981. # web config
  982. function_check add_ddns_domain
  983. add_ddns_domain "$PLEROMA_DOMAIN_NAME"
  984. PLEROMA_ONION_HOSTNAME=$(add_onion_service pleroma 80 ${PLEROMA_ONION_PORT})
  985. pleroma_nginx_site=/etc/nginx/sites-available/$PLEROMA_DOMAIN_NAME
  986. if [[ $ONION_ONLY == "no" ]]; then
  987. function_check nginx_http_redirect
  988. nginx_http_redirect "$PLEROMA_DOMAIN_NAME" "index index.html"
  989. { echo '';
  990. echo 'proxy_cache_path /tmp/pleroma-media-cache levels=1:2 keys_zone=pleroma_media_cache:10m max_size=100m inactive=80m use_temp_path=off;';
  991. echo '';
  992. echo 'server {';
  993. echo ' listen 443 ssl http2;';
  994. echo ' #listen [::]:443 ssl http2;';
  995. echo " server_name $PLEROMA_DOMAIN_NAME;";
  996. echo '';
  997. echo ' # Security'; } >> "$pleroma_nginx_site"
  998. function_check nginx_ssl
  999. nginx_ssl "$PLEROMA_DOMAIN_NAME"
  1000. function_check nginx_security_options
  1001. nginx_security_options "$PLEROMA_DOMAIN_NAME"
  1002. { echo ' add_header Strict-Transport-Security max-age=0;';
  1003. echo '';
  1004. echo ' # Logs';
  1005. echo ' access_log /dev/null;';
  1006. echo ' error_log /dev/null;';
  1007. echo '';
  1008. echo " root $PLEROMA_DIR;";
  1009. echo '';
  1010. echo ' index index.html;';
  1011. echo '';
  1012. echo ' gzip_vary on;';
  1013. echo ' gzip_proxied any;';
  1014. echo ' gzip_comp_level 6;';
  1015. echo ' gzip_buffers 16 8k;';
  1016. echo ' gzip_http_version 1.1;';
  1017. echo ' gzip_types text/plain text/css application/json application/javascript text/xml application/xml application/xml+rss text/javascript application/activity+json application/atom+xml;';
  1018. echo '';
  1019. echo ' location / {';
  1020. echo ' client_max_body_size 15m;';
  1021. echo ' client_body_buffer_size 15m;';
  1022. echo '';
  1023. echo ' limit_conn conn_limit_per_ip 50;';
  1024. echo ' limit_req zone=req_limit_per_ip burst=50 nodelay;';
  1025. echo '';
  1026. echo " add_header 'Access-Control-Allow-Origin' '*' always;";
  1027. echo " add_header 'Access-Control-Allow-Methods' 'POST, GET, OPTIONS' always;";
  1028. echo " add_header 'Access-Control-Allow-Headers' 'Authorization, Content-Type' always;";
  1029. echo " if (\$request_method = OPTIONS) {";
  1030. echo ' return 204;';
  1031. echo ' }';
  1032. echo '';
  1033. echo ' proxy_http_version 1.1;';
  1034. echo " proxy_set_header Upgrade \$http_upgrade;";
  1035. echo ' proxy_set_header Connection "upgrade";';
  1036. echo " proxy_set_header Host \$http_host;";
  1037. echo '';
  1038. echo " proxy_pass http://localhost:$PLEROMA_PORT;";
  1039. echo ' }';
  1040. echo '';
  1041. echo ' location /proxy {';
  1042. echo ' client_max_body_size 15m;';
  1043. echo ' client_body_buffer_size 15m;';
  1044. echo '';
  1045. echo ' limit_conn conn_limit_per_ip 50;';
  1046. echo ' limit_req zone=req_limit_per_ip burst=50 nodelay;';
  1047. echo '';
  1048. echo ' proxy_cache pleroma_media_cache;';
  1049. echo ' proxy_cache_lock on;';
  1050. echo " proxy_pass http://localhost:$PLEROMA_PORT;";
  1051. echo ' }';
  1052. echo ' # include snippets/well-known.conf;';
  1053. echo '}'; } >> "$pleroma_nginx_site"
  1054. else
  1055. echo 'proxy_cache_path /tmp/pleroma-media-cache levels=1:2 keys_zone=pleroma_media_cache:10m max_size=100m inactive=80m use_temp_path=off;' > "$pleroma_nginx_site"
  1056. echo '' >> "$pleroma_nginx_site"
  1057. fi
  1058. { echo 'server {';
  1059. echo " listen 127.0.0.1:$PLEROMA_ONION_PORT default_server;";
  1060. echo " server_name $PLEROMA_ONION_HOSTNAME;";
  1061. echo ''; } >> "$pleroma_nginx_site"
  1062. function_check nginx_security_options
  1063. nginx_security_options "$PLEROMA_DOMAIN_NAME"
  1064. { echo '';
  1065. echo ' # Logs';
  1066. echo ' access_log /dev/null;';
  1067. echo ' error_log /dev/null;';
  1068. echo '';
  1069. echo " root $PLEROMA_DIR;";
  1070. echo '';
  1071. echo ' index index.html;';
  1072. echo '';
  1073. echo ' gzip_vary on;';
  1074. echo ' gzip_proxied any;';
  1075. echo ' gzip_comp_level 6;';
  1076. echo ' gzip_buffers 16 8k;';
  1077. echo ' gzip_http_version 1.1;';
  1078. echo ' gzip_types text/plain text/css application/json application/javascript text/xml application/xml application/xml+rss text/javascript application/activity+json application/atom+xml;';
  1079. echo '';
  1080. echo ' location / {';
  1081. echo ' client_max_body_size 15m;';
  1082. echo ' client_body_buffer_size 15m;';
  1083. echo '';
  1084. echo ' limit_conn conn_limit_per_ip 50;';
  1085. echo ' limit_req zone=req_limit_per_ip burst=50 nodelay;';
  1086. echo '';
  1087. echo " add_header 'Access-Control-Allow-Origin' '*' always;";
  1088. echo " add_header 'Access-Control-Allow-Methods' 'POST, GET, OPTIONS' always;";
  1089. echo " add_header 'Access-Control-Allow-Headers' 'Authorization, Content-Type' always;";
  1090. echo " if (\$request_method = OPTIONS) {";
  1091. echo ' return 204;';
  1092. echo ' }';
  1093. echo '';
  1094. echo ' proxy_http_version 1.1;';
  1095. echo " proxy_set_header Upgrade \$http_upgrade;";
  1096. echo ' proxy_set_header Connection "upgrade";';
  1097. echo " proxy_set_header Host \$http_host;";
  1098. echo '';
  1099. echo " proxy_pass http://localhost:$PLEROMA_PORT;";
  1100. echo ' }';
  1101. echo '';
  1102. echo ' location /proxy {';
  1103. echo ' client_max_body_size 15m;';
  1104. echo ' client_body_buffer_size 15m;';
  1105. echo '';
  1106. echo ' limit_conn conn_limit_per_ip 50;';
  1107. echo ' limit_req zone=req_limit_per_ip burst=50 nodelay;';
  1108. echo '';
  1109. echo ' proxy_cache pleroma_media_cache;';
  1110. echo ' proxy_cache_lock on;';
  1111. echo " proxy_pass http://localhost:$PLEROMA_PORT;";
  1112. echo ' }';
  1113. echo ' # include snippets/well-known.conf;';
  1114. echo '}'; } >> "$pleroma_nginx_site"
  1115. # back end
  1116. cd "$PLEROMA_DIR" || exit 246824684
  1117. chown -R pleroma:pleroma "$PLEROMA_DIR/"*
  1118. if ! sudo -u pleroma mix local.hex --force; then
  1119. echo $'mix local.hex failed'
  1120. exit 1745673
  1121. fi
  1122. mix local.hex --force
  1123. if ! sudo -u pleroma mix deps.get --force; then
  1124. echo $'mix deps.get failed'
  1125. exit 7325733
  1126. fi
  1127. function_check pleroma_create_database
  1128. pleroma_create_database
  1129. "${PROJECT_NAME}-pass" -u "$MY_USERNAME" -a pleroma -p "$PLEROMA_ADMIN_PASSWORD"
  1130. # NOTE: we don't need to install the frontend separately,
  1131. # since the backend contains a precompiled version of it
  1132. install_gnusocial_default_background "pleroma" "$PLEROMA_DOMAIN_NAME"
  1133. if [ ! -f "$PLEROMA_DIR/priv/static/static/config.json" ]; then
  1134. echo $"$PLEROMA_DIR/priv/static/static/config.json file missing"
  1135. exit 323689
  1136. fi
  1137. sed -i 's|"theme":.*|"theme": "base16-summerfruit-dark.css",|g' "$PLEROMA_DIR/priv/static/static/config.json"
  1138. if [ "$PLEROMA_BACKGROUND_IMAGE_URL" ]; then
  1139. pleroma_set_background_image_from_url $PLEROMA_DIR/priv/static "$PLEROMA_DOMAIN_NAME" "$PLEROMA_BACKGROUND_IMAGE_URL" "$PLEROMA_TITLE"
  1140. fi
  1141. # Get certificate
  1142. function_check create_site_certificate
  1143. create_site_certificate "$PLEROMA_DOMAIN_NAME" 'yes'
  1144. function_check nginx_ensite
  1145. nginx_ensite "$PLEROMA_DOMAIN_NAME"
  1146. systemctl restart postgresql
  1147. systemctl restart nginx
  1148. set_completion_param "pleroma domain" "$PLEROMA_DOMAIN_NAME"
  1149. # We need to set up the url option again because it somehow gets
  1150. # lost during mix compile
  1151. if ! grep -q 'watchers: \[],' $pleroma_secret; then
  1152. sed -i 's|watchers: \[\]|watchers: \[\],|g' $pleroma_secret
  1153. fi
  1154. if ! grep -q 'url:' $pleroma_secret; then
  1155. if [[ $ONION_ONLY == 'no' ]]; then
  1156. sed -i "/watchers: /a url: [host: \"$PLEROMA_DOMAIN_NAME\", scheme: \"https\", port: 443]" $pleroma_secret
  1157. else
  1158. sed -i "/watchers: /a url: [host: \"$PLEROMA_ONION_HOSTNAME\", scheme: \"http\", port: 80]" $pleroma_secret
  1159. fi
  1160. fi
  1161. create_pleroma_blocklist
  1162. # daemon
  1163. { echo '[Unit]';
  1164. echo 'Description=Pleroma social network';
  1165. echo 'After=network.target postgresql.service';
  1166. echo '';
  1167. echo '[Service]';
  1168. echo 'User=pleroma';
  1169. echo "WorkingDirectory=$PLEROMA_DIR";
  1170. echo "Environment=\"HOME=$PLEROMA_DIR\"";
  1171. echo 'ExecStart=/usr/local/bin/mix phx.server';
  1172. echo "ExecReload=/bin/kill \$MAINPID";
  1173. echo 'KillMode=process';
  1174. echo 'Restart=on-failure';
  1175. echo '';
  1176. echo '[Install]';
  1177. echo 'WantedBy=multi-user.target';
  1178. echo 'Alias=pleroma.service'; } > /etc/systemd/system/pleroma.service
  1179. # avoid mixed content warnings
  1180. sed -i '/config :pleroma, :media_proxy/!b;n;c####enabled: true,' $PLEROMA_DIR/config/config.exs
  1181. sed -i 's|####enabled| enabled|g' $PLEROMA_DIR/config/config.exs
  1182. sed -i 's|redirect_on_failure:.*|redirect_on_failure: false|g' $PLEROMA_DIR/config/config.exs
  1183. sed -i 's|:chat, enabled:.*|:chat, enabled: false|g' $PLEROMA_DIR/config/config.exs
  1184. # onion routing
  1185. sed -i '/url:/a config :pleroma, :http, proxy_url: {:socks5, :localhost, 9050}' $pleroma_secret
  1186. sed -i 's|config :pleroma, :http, proxy_url:|# config :pleroma, :http, proxy_url:|g' $PLEROMA_DIR/config/config.exs
  1187. # set registrations open initially
  1188. sed -i 's|registrations_open:.*|registrations_open: true,|g' $PLEROMA_DIR/config/config.exs
  1189. sed -i 's|"registrationOpen":.*|"registrationOpen": true,|g' $PLEROMA_DIR/priv/static/static/config.json
  1190. if ! grep -q "media_proxy" $PLEROMA_DIR/priv/static/static/config.json; then
  1191. sed -i '/"name":/a "media_proxy": true,' $PLEROMA_DIR/priv/static/static/config.json
  1192. sed -i 's|"media_proxy"| "media_proxy"|g' $PLEROMA_DIR/priv/static/static/config.json
  1193. else
  1194. sed -i 's|"media_proxy".*|"media_proxy": false,|g' $PLEROMA_DIR/priv/static/static/config.json
  1195. fi
  1196. sed -i 's|"chatDisabled":.*|"chatDisabled": true,|g' $PLEROMA_DIR/priv/static/static/config.json
  1197. pleroma_add_filtering
  1198. systemctl daemon-reload
  1199. systemctl enable pleroma
  1200. systemctl start pleroma
  1201. cd $PLEROMA_DIR || exit 1935638
  1202. mix register_user "$MY_USERNAME" "$MY_USERNAME" "$MY_EMAIL_ADDRESS" $"Your bio goes here" "$PLEROMA_ADMIN_PASSWORD"
  1203. APP_INSTALLED=1
  1204. }
  1205. # NOTE: deliberately there is no "exit 0"